<template>
  <Bar v-if="data.length > 0 && labels.length > 0" :data="chartData" :options="chartOptions"></Bar>
  <span v-else class="d-flex align-center justify-center text-grey mt-12"><h3>No Data</h3></span>
</template>

<script setup lang="ts">
import { Bar } from 'vue-chartjs'
import Chart from 'chart.js/auto'
import { computed } from 'vue'
import { monthShort } from '@/utils/date'
import { Colors } from 'chart.js'

Chart.register(Colors)

const props = defineProps<{
  data: any[]
  labels: (string | number)[]
}>()

const sortedData = computed(() => {
  return [...props.data].sort((a, b) => (a < b ? -1 : 1)) // Concise asc sort
})

const sortedLabels = computed(() => {
  const areStringLabels = Array.isArray(props.labels.join(' '))

  return [...props.labels].sort((a: any, b: any) => {
    if (areStringLabels) {
      const monthIndexA = monthShort.indexOf(a)
      const monthIndexB = monthShort.indexOf(b)
      return monthIndexA - monthIndexB
    } else {
      return a < b ? -1 : 1 // Default numeric sort
    }
  })
})

const chartData = computed(() => ({
  labels: sortedLabels.value,
  datasets: [
    {
      data: sortedData.value,
      backgroundColor: ['#ff6384', '#36a2eb', '#ffce56']
    }
  ]
}))

const chartOptions = computed(() => ({
  responsive: true,
  plugins: {
    colors: {
      enabled: true
    },
    legend: {
      display: false
    }
  }
}))
</script>
